package de.mrbesen.test;

import java.util.Scanner;

import de.mrbesen.telegram.TelegramAPI;
import de.mrbesen.telegram.event.events.UserSendMessageEvent;
import de.mrbesen.telegram.objects.TMessage;
import de.mrbesen.telegram.objects.TUser.Status;
import de.mrbesen.test.commands.InlineKeyboardTC;
import de.mrbesen.test.commands.ReplyKeyboardRemoveTC;
import de.mrbesen.test.commands.ReplyKeyboardTestCase;
import de.mrbesen.test.commands.SimpleTestCase;

public class Main implements Runnable {

	TelegramAPI api;
	private int action = 0;
	private TMessage oldmsg = null;

	public static void main(String[] args) {
		new Main().run();
	}

	public Main() {
		String token = "577609137:AAGrlfMHAOQPzN6w9ceNSgFZZCbaiK4gAnw";//test token
		api = new TelegramAPI(token);
		api.getCommandManager().registerCommand(new SimpleTestCase());
		api.getCommandManager().registerCommand(new InlineKeyboardTC());
		api.getCommandManager().registerCommand(new ReplyKeyboardTestCase());
		api.getCommandManager().registerCommand(new ReplyKeyboardRemoveTC());
		api.getEventManager().registerEvent(UserSendMessageEvent.class, this::handleEvent);
	}
	
	public void handleEvent(Object event) {
		UserSendMessageEvent e = (UserSendMessageEvent) event;
		//api.sendMessage(new MessageBuilder().setText("this is a reply").setReciver(e.getUser().getID()).setSilent(true).setNoWebView(true).build());
		
		if(oldmsg != null) {
			oldmsg.forward(e.getUser());
		}
		
		if(e.getMessage().getText().toLowerCase().startsWith("hey")) {
			api.sendTypedMessage("Hello!", e.getUser(), 4);
		}
		//e.getUser().sendStatus(Status.values()[action++]);
		action%=Status.values().length;
		oldmsg = e.getMessage();
	}
	
	@Override
	public void run() {
		api.start();
		Scanner s = new Scanner(System.in);
		s.nextLine();
		s.close();
		api.stop();
		System.out.println("Terminated.");
	}

}
